improve ARM feature detection
[pcsx_rearmed.git] / configure
... / ...
CommitLineData
1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
9rm -f config.log
10
11compile_object()
12{
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
27 echo "" > $TMPC
28 $CC -E -dD $CFLAGS $TMPC | grep -q $1 || return 1
29 return 0
30}
31
32# setting options to "yes" or "no" will make that choice default,
33# "" means "autodetect".
34
35platform_list="generic pandora maemo caanoo libretro"
36platform="generic"
37builtin_gpu_list="peops unai neon"
38builtin_gpu=""
39sound_driver_list="oss alsa sdl pulseaudio libretro"
40sound_drivers=""
41plugins="plugins/spunull/spunull.so \
42plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
43ram_fixed="no"
44drc_cache_base="no"
45have_armv6=""
46have_armv7=""
47have_arm_neon=""
48have_tslib=""
49enable_dynarec="yes"
50need_sdl="no"
51need_libpicofe="yes"
52need_warm="no"
53# these are for known platforms
54optimize_cortexa8="no"
55optimize_arm926ej="no"
56
57# hardcoded stuff
58CC="${CC-${CROSS_COMPILE}gcc}"
59CXX="${CXX-${CROSS_COMPILE}g++}"
60AS="${AS-${CROSS_COMPILE}as}"
61AR="${AS-${CROSS_COMPILE}ar}"
62MAIN_LDLIBS="$LDLIBS -ldl -lm"
63config_mak="config.mak"
64
65fail()
66{
67 echo "$@"
68 exit 1
69}
70
71# call during arg parsing, so that cmd line can override platform defaults
72set_platform()
73{
74 platform=$1
75 case "$platform" in
76 generic)
77 ;;
78 pandora)
79 sound_drivers="oss alsa"
80 ram_fixed="yes"
81 drc_cache_base="yes"
82 optimize_cortexa8="yes"
83 have_arm_neon="yes"
84 ;;
85 maemo)
86 ram_fixed="yes"
87 drc_cache_base="yes"
88 optimize_cortexa8="yes"
89 have_arm_neon="yes"
90 ;;
91 caanoo)
92 sound_drivers="oss"
93 ram_fixed="yes"
94 drc_cache_base="yes"
95 optimize_arm926ej="yes"
96 need_warm="yes"
97 ;;
98 libretro)
99 sound_drivers="libretro"
100 need_libpicofe="no"
101 ;;
102 *)
103 fail "unsupported platform: $platform"
104 ;;
105 esac
106}
107
108for opt do
109 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
110 case "$opt" in
111 --help|-h) show_help="yes"
112 ;;
113 --platform=*) set_platform "$optarg"
114 ;;
115 --gpu=*) builtin_gpu="$optarg"
116 ;;
117 --sound-drivers=*) sound_drivers="$optarg"
118 ;;
119 --enable-neon) have_arm_neon="yes"
120 ;;
121 --disable-neon) have_arm_neon="no"
122 ;;
123 --disable-dynarec) enable_dynarec="no"
124 ;;
125 *) echo "ERROR: unknown option $opt"; show_help="yes"
126 ;;
127 esac
128done
129
130if [ "$show_help" = "yes" ]; then
131 echo "options:"
132 echo " --help print this message"
133 echo " --platform=NAME target platform [$platform]"
134 echo " available: $platform_list"
135 echo " --gpu=NAME builtin gpu plugin [guessed]"
136 echo " available: $builtin_gpu_list"
137 echo " --sound-drivers=LIST sound output drivers [guessed]"
138 echo " available: $sound_driver_list"
139 echo " --enable-neon"
140 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
141 echo " --disable-dynarec disable dynamic recompiler"
142 echo " (dynarec is only available and enabled on ARM)"
143 echo "influential environment variables:"
144 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
145 exit 1
146fi
147
148# validate selections
149if [ "x$builtin_gpu" != "x" ]; then
150 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
151 fail "unsupported builtin gpu plugin: $builtin_gpu"
152 fi
153fi
154
155if [ "x$sound_drivers" != "x" ]; then
156 for d in $sound_drivers; do
157 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
158 fail "unsupported sound driver: $sound_driver"
159 fi
160 done
161fi
162
163if [ "$need_libpicofe" = "yes" ]; then
164 if ! test -f "frontend/libpicofe/README"; then
165 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
166 fi
167fi
168
169if [ "$need_warm" = "yes" ]; then
170 if ! test -f "frontend/warm/README"; then
171 fail "wARM is missing, please run 'git submodule init && git submodule update'"
172 fi
173fi
174
175if [ -z "$ARCH" ]; then
176 ARCH=`$CC -v 2>&1 | grep -i 'target:' | awk '{print $2}' \
177 | awk -F '-' '{print $1}'`
178fi
179
180# ARM stuff
181if [ "$ARCH" = "arm" ]; then
182 if [ "$optimize_cortexa8" = "yes" ]; then
183 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
184 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
185 fi
186 if [ "$optimize_arm926ej" = "yes" ]; then
187 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
188 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
189 fi
190
191 if [ "x$have_arm_neon" = "x" ]; then
192 # detect NEON from user-supplied cflags to enable asm code
193 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
194 fi
195 if [ "x$have_armv6" = "x" ]; then
196 have_armv6=`check_define __ARM_ARCH_6 && echo yes` || true
197 fi
198 if [ "x$have_armv7" = "x" ]; then
199 if check_define __ARM_ARCH_7A__; then
200 have_armv6="yes"
201 have_armv7="yes"
202 fi
203 fi
204
205 if [ "x$builtin_gpu" = "x" ]; then
206 if [ "$have_arm_neon" = "yes" ]; then
207 builtin_gpu="neon"
208 elif [ "$have_armv7" != "yes" ]; then
209 # pre-ARMv7 hardware is usually not fast enough for peops
210 builtin_gpu="unai"
211 else
212 builtin_gpu="peops"
213 fi
214 fi
215
216 # automatically set mfpu and mfloat-abi if they are not set
217 if [ "$have_arm_neon" = "yes" ]; then
218 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=neon"
219 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=neon"
220 elif [ "$have_armv6" = "yes" ]; then
221 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=vfp"
222 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=vfp"
223 fi
224 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
225 if [ "$floatabi_set_by_gcc" != "yes" -a "$have_armv6" = "yes" ]; then
226 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
227 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
228 fi
229
230 # must disable thumb as recompiler can't handle it
231 if check_define __thumb__; then
232 CFLAGS="$CFLAGS -marm"
233 fi
234else
235 # dynarec only available on ARM
236 enable_dynarec="no"
237fi
238
239if [ "x$builtin_gpu" = "x" ]; then
240 builtin_gpu="peops"
241fi
242
243# supposedly we can avoid -fPIC on armv5 for slightly better performace?
244if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
245 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
246fi
247
248if [ "$ram_fixed" = "yes" ]; then
249 CFLAGS="$CFLAGS -DRAM_FIXED"
250fi
251
252case "$platform" in
253generic)
254 need_sdl="yes"
255 ;;
256maemo)
257 maemo_cflags=`pkg-config --cflags hildon-1`
258 maemo_ldlibs=`pkg-config --libs hildon-1`
259 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES $maemo_cflags"
260 MAIN_LDLIBS="$MAIN_LDLIBS $maemo_ldlibs"
261 ;;
262libretro)
263 CFLAGS="$CFLAGS -fPIC"
264 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
265 ;;
266esac
267
268# header/library presence tests
269check_zlib()
270{
271 cat > $TMPC <<EOF
272 #include <zlib.h>
273 int main(void) { uncompress(0, 0, 0, 0); }
274EOF
275 compile_binary
276}
277
278check_libpng()
279{
280 cat > $TMPC <<EOF
281 #include <png.h>
282 void main() { png_init_io(0, 0); }
283EOF
284 compile_binary
285}
286
287check_oss()
288{
289 cat > $TMPC <<EOF
290 #include <sys/soundcard.h>
291 #include <sys/ioctl.h>
292 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
293EOF
294 compile_binary
295}
296
297check_alsa()
298{
299 cat > $TMPC <<EOF
300 #include <alsa/asoundlib.h>
301 void main() { snd_pcm_open(0, 0, 0, 0); }
302EOF
303 compile_binary "$@"
304}
305
306check_sdl()
307{
308 cat > $TMPC <<EOF
309 #include <SDL.h>
310 void main() { SDL_OpenAudio(0, 0); }
311EOF
312 compile_binary "$@"
313}
314
315MAIN_LDLIBS="$MAIN_LDLIBS -lz"
316check_zlib || fail "please install zlib (libz-dev)"
317
318MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
319check_libpng || fail "please install libpng (libpng-dev)"
320
321# find what audio support we can compile
322if [ "x$sound_drivers" = "x" ]; then
323 if check_oss; then sound_drivers="$sound_drivers oss"; fi
324 if check_alsa -lasound; then
325 sound_drivers="$sound_drivers alsa"
326 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
327 fi
328 if [ "$need_sdl" = "yes" ] || check_sdl `sdl-config --cflags --libs`; then
329 sound_drivers="$sound_drivers sdl"
330 need_sdl="yes"
331 fi
332else
333 if echo $sound_drivers | grep -q "\<oss\>"; then
334 check_oss || fail "oss support is missing"
335 fi
336 if echo $sound_drivers | grep -q "\<alsa\>"; then
337 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
338 check_alsa || fail "please install libasound2-dev"
339 fi
340fi
341
342if [ "$need_sdl" = "yes" ]; then
343 which sdl-config > /dev/null || \
344 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
345 CFLAGS="$CFLAGS `sdl-config --cflags`"
346 MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS"
347 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
348fi
349
350# check for tslib (only headers needed)
351if [ "x$have_tslib" = "x" ]; then
352 cat > $TMPC <<EOF
353 #include <tslib.h>
354 void test(struct ts_sample sample) {}
355EOF
356 if compile_object; then
357 have_tslib="yes"
358 else
359 have_tslib="no"
360 fi
361fi
362
363# check for GLES headers
364cat > $TMPC <<EOF
365#include <GLES/gl.h>
366#include <GLES/glext.h>
367#include <EGL/egl.h>
368void *test(void) {
369 return eglGetDisplay( (EGLNativeDisplayType)0 );
370}
371EOF
372if compile_object; then
373 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
374fi
375
376if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
377 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
378fi
379
380cat > $TMPC <<EOF
381void test(void *f, void *d) { fread(d, 1, 1, f); }
382EOF
383if compile_object -Wno-unused-result; then
384 CFLAGS="$CFLAGS -Wno-unused-result"
385fi
386
387# short plugin list for display
388for p in $plugins; do
389 p1=`basename $p`
390 plugins_short="$p1 $plugins_short"
391done
392
393# set things that failed to autodetect to "no"
394test "x$have_armv6" != "x" || have_armv6="no"
395test "x$have_armv7" != "x" || have_armv7="no"
396test "x$have_arm_neon" != "x" || have_arm_neon="no"
397
398echo "architecture $ARCH"
399echo "platform $platform"
400echo "built-in GPU $builtin_gpu"
401echo "sound drivers $sound_drivers"
402echo "plugins $plugins_short"
403echo "C compiler $CC"
404echo "C compiler flags $CFLAGS"
405echo "libraries $MAIN_LDLIBS"
406echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
407echo "enable dynarec $enable_dynarec"
408echo "ARMv7 optimizations $have_armv7"
409echo "enable ARM NEON $have_arm_neon"
410echo "tslib support $have_tslib"
411
412echo "# Automatically generated by configure" > $config_mak
413printf "# Configured with:" >> $config_mak
414printf " '%s'" "$0" "$@" >> $config_mak
415echo >> $config_mak
416
417echo "CC = $CC" >> $config_mak
418echo "CXX = $CXX" >> $config_mak
419echo "AS = $AS" >> $config_mak
420echo "CFLAGS += $CFLAGS" >> $config_mak
421echo "ASFLAGS += $ASFLAGS" >> $config_mak
422echo "LDFLAGS += $LDFLAGS" >> $config_mak
423echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
424echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
425echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
426echo >> $config_mak
427
428if [ "$platform" = "libretro" ]; then
429 echo "TARGET = libretro.so" >> $config_mak
430fi
431echo "ARCH = $ARCH" >> $config_mak
432echo "PLATFORM = $platform" >> $config_mak
433echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
434echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
435echo "PLUGINS = $plugins" >> $config_mak
436if [ "$have_arm_neon" = "yes" ]; then
437 echo "HAVE_NEON = 1" >> $config_mak
438fi
439if [ "$have_tslib" = "yes" ]; then
440 echo "HAVE_TSLIB = 1" >> $config_mak
441fi
442if [ "$enable_dynarec" = "yes" ]; then
443 echo "USE_DYNAREC = 1" >> $config_mak
444fi
445if [ "$drc_cache_base" = "yes" ]; then
446 echo "DRC_CACHE_BASE = 1" >> $config_mak
447fi
448
449# use pandora's skin (for now)
450test -e skin || ln -s frontend/pandora/skin skin
451
452# vim:shiftwidth=2:expandtab